C------------------------------------------------
      FUNCTION CLTRKLEV2()
C------------------------------------------------
C     Written by Emiliano Mocchiutti
C     v. 0.2
C
      INCLUDE 'COMMON2.TXT'
      INTEGER cltrklev2
      REAL hmemor(9000000)
      integer Iquest(100)    
      COMMON /pawc/hmemor
      save /pawc/
      Common /QUEST/ Iquest
      save /quest/
c
c
      cltrklev2 = 0
      call HCDIR('//LEVEL2',' ')
      call HREND('level2')
      CLOSE (81)
CC
 52   continue
      RETURN
      END

C------------------------------------------------
      FUNCTION OPTOFLEV1(name,trnev)
C------------------------------------------------
C     Written by Emiliano Mocchiutti
C     v. 0.2
C	  
      INCLUDE 'COMMONTOF.TXT'
C
      CHARACTER*100 name
C
      INTEGER lrec, optoflev1,trnev
      INTEGER istat
      PARAMETER (lrec=8190)
      REAL hmemor(9000000)
      integer Iquest(100)    
      COMMON /pawc/hmemor
      save /pawc/
      Common /QUEST/ Iquest
      save /quest/
      CALL HLIMIT(9000000)
      Iquest(10) = 256000
C
      optoflev1 = 0
      trnev = 0
C 
C     CHANGE here (hbname and hbnt if you want another ntuple id number
C
      call HROPEN(89,'TOF',name,'QP',4096,istat)
      if(istat.ne.0) goto 19      
      call HRIN(2,9999,0)       
      call access_tof
      call HNOENT(2,trnev)

 19   continue

C
c
      RETURN
      END


      SUBROUTINE access_tof
*
      include 'COMMONTOF.TXT'

      CALL HBNAME(2,' ',0,'$CLEAR')
*
      CALL HBNAME(2,'EVENT',GOOD2,'$SET')
*
      CALL HBNAME(2,'CPU',PKT_TYPE,'$SET')
*
      CALL HBNAME(2,'TOF',TDCID,'$SET')
*
      CALL HBNAME(2,'TRIGGER',TRIG_EVCOUNT,'$SET')
*
      CALL HBNAME(2,'TRACKS',NTRK,'$SET')
*
      CALL HBNAME(2,'SINGLETS',NCLSX,'$SET')
*

*
      return
      END

C------------------------------------------------
      FUNCTION RETOFLEV1(evno)
C------------------------------------------------
C     Written by Emiliano Mocchiutti
C     v. 0.2
C
      INCLUDE 'COMMONTOF.TXT'
      integer retoflev1, evno, ierr
      REAL hmemor(9000000)
      integer Iquest(100)    
      COMMON /pawc/hmemor
      save /pawc/
      Common /QUEST/ Iquest
      save /quest/

C         
C     change here if you changed the ntuple id number     
C
      retoflev1 = 0
      call HCDIR('//TOF',' ')
      call HGNT(2,evno,ierr)
      if (ierr.ne.0) print *,'Error reading tracker ntuple'
c      if (ntrk.eq.1) print *,' RIG = ',1./al(5,1)
C
      RETURN
      END

C------------------------------------------------
      FUNCTION CLTOFLEV1()
C------------------------------------------------
C     Written by Emiliano Mocchiutti
C     v. 0.2
C
      INCLUDE 'COMMONTOF.TXT'
      INTEGER cltoflev1
      REAL hmemor(9000000)
      integer Iquest(100)    
      COMMON /pawc/hmemor
      save /pawc/
      Common /QUEST/ Iquest
      save /quest/
c
c
      cltoflev1 = 0
      call HCDIR('//TOF',' ')
      call HREND('TOF')
      CLOSE (89)
CC
 52   continue
      RETURN
      END

C------------------------------------------------
      FUNCTION OPTRKLEV2(name,trnev)
C------------------------------------------------
C     Written by Emiliano Mocchiutti
C     v. 0.2
C	  
      INCLUDE 'COMMON2.TXT'
C
      CHARACTER*100 name
C
      INTEGER lrec, optrklev2,trnev
      INTEGER istat
      PARAMETER (lrec=8190)
      REAL hmemor(9000000)
      integer Iquest(100)    
      COMMON /pawc/hmemor
      save /pawc/
      Common /QUEST/ Iquest
      save /quest/
      CALL HLIMIT(9000000)
      Iquest(10) = 256000
C
      optrklev2 = 0
      trnev = 0
C 
C     CHANGE here (hbname and hbnt if you want another ntuple id number
C
      call HROPEN(81,'LEVEL2',name,'QP',4096,istat)
      if(istat.ne.0) goto 19      
      call HRIN(22,9999,20)       
      call access_level2
      call HNOENT(42,trnev)

 19   continue

C
c
      RETURN
      END


      SUBROUTINE access_level2
*
      include 'COMMON2.TXT'

      CALL HBNAME(42,' ',0,'$CLEAR')
*
      CALL HBNAME(42,'GENERAL',GOOD2,'$SET')
*
      CALL HBNAME(42,'CPU',PKT_TYPE,'$SET')
*
      CALL HBNAME(42,'TRACKS',NTRK,'$SET')
*
      CALL HBNAME(42,'SINGLETX',NCLSX,'$SET')
*
      CALL HBNAME(42,'SINGLETY',NCLSY,'$SET')
*

*
      return
      END
